<?php if(!class_exists('lemiho_subscriber')) :
    class lemiho_subscriber {
            /**
             *@action run system marketing 
            */
            public function lemiho_subscriber_sent_email_all(){
                if(isset($_POST['lemiho_sent_email_all'])){
                    $lemiho_subscriber_database = new lemiho_subscriber_database;
                     $lemiho_subscriber = new lemiho_subscriber;
                    $data = $lemiho_subscriber_database->lemiho_subsciber_get_subscriber();
                    $_content = get_option('sent_mail_content');
                    $title = esc_html(get_option('lemiho_subsciber_title_email'));
                    $_SESSION['lemiho_data_report_success'] = 0;
                    $_SESSION['lemiho_data_report_error'] = 0;
                    foreach($data as $action ){
                        $unsubscriber_link = '<br/><div style="width:100%;padding:10px;text-align:right;"><a href="' . home_url() . '?lemiho_subscriber=1&lemiho_user_id=' . $action->id . '&lemiho_token=' . $action->data_key . '">Do you want unsubscriber ? </a></div>';
                        $content = $unsubscriber_link . '<br/>' . $_content;
                        $sent = $lemiho_subscriber->lemiho_subscriber_sent_email($action->email,$title,$content);
                        if($sent) {
                            $success = $_SESSION['lemiho_data_report_success'] + 1;
                            $_SESSION['lemiho_data_report_success'] = $success;
                        } else {
                            $error = $_SESSION['lemiho_data_report_error'] + 1;
                            $_SESSION['lemiho_data_report_error'] = $error;
                        }
                    }
                    // create report
                    $lemiho_subscriber_database->lemiho_subscriber_database_create_report($_SESSION['lemiho_data_report_success'],$_SESSION['lemiho_data_report_error']);
                    unset($_SESSION['lemiho_data_report_success'],$_SESSION['lemiho_data_report_error']);
                }
                    
            }
            public function lemiho_subscriber_display_page(){
                $lemiho_subscriber = new lemiho_subscriber;
                add_thickbox();
                wp_enqueue_script('media-upload');
                wp_enqueue_media();
                wp_enqueue_style('bootstrap.min.css',plugins_url(LEMIHO_URL . '/assets/bootstrap/css/bootstrap.min.css'));
                wp_enqueue_style('lemiho-subsciber.css',plugins_url(LEMIHO_URL . '/assets/css/lemiho-subsciber.css'));
                wp_enqueue_style('lemiho-subsciber-default-style.css',plugins_url(LEMIHO_URL . '/assets/css/lemiho-subsciber-default-style.css'));
                wp_enqueue_script('lemiho-subsciber-tabs.js',plugins_url(LEMIHO_URL . '/assets/js/lemiho-subsciber-tabs.js'));
                wp_enqueue_script('lemiho_excel.js',plugins_url(LEMIHO_URL . '/assets/js/lemiho_excel.js'));
                $lemiho_subscriber->lemiho_subscriber_sent_email_all();
                $lemiho_subscriber->lemiho_subscriber_delete_report();
                $lemiho_subscriber->lemiho_subscriber_add_keywords();
                $lemiho_subscriber->lemiho_subscriber_delete_keyword();
                $lemiho_subscriber->lemiho_subscriber_action_export();
                $lemiho_subscriber->lemiho_subscriber_action_delete_file_excel();
                require_once( LEMIHO_SUBSCRIBER . 'template/options.php' );
                // color picker 
                wp_enqueue_style('colorpicker.css',plugins_url(LEMIHO_URL . '/assets/color/css/colorpicker.css'));
                wp_enqueue_script('colorpicker.js',plugins_url(LEMIHO_URL . '/assets/color/js/colorpicker.js'));
                //admin
                wp_enqueue_script('admin.js',plugins_url(LEMIHO_URL . '/assets/js/admin.js'));
                // chart 
                wp_enqueue_script('chart.js',plugins_url(LEMIHO_URL . '/assets/js/chart.js'));
                wp_enqueue_script('bundle.js',plugins_url(LEMIHO_URL . '/assets/js/bundle.js'));
                // keyword 
                wp_enqueue_script('keywords.js',plugins_url(LEMIHO_URL . '/assets/js/keywords.js'));
            } 
            public function lemiho_subscriber_manage_page(){
                $lemiho_subscriber = new lemiho_subscriber;
                add_menu_page('Lemiho Subsciber','Lemiho Subsciber','manage_options','lemiho-subsciber',array($lemiho_subscriber,'lemiho_subscriber_display_page'),'dashicons-email-alt',99);
            }
            public function lemiho_subscriber_section_field(){
                    add_settings_section($id = 'lemiho_subscriber_data', $title = "Setting", NULL, $page = 'theme-options');
                    if(isset($_POST)) :
                        $post = array_keys($_POST);
                        foreach($post as $action ) {
                                register_setting($section = 'lemiho_subscriber_data', sanitize_text_field($action)); 
                        }
                    endif;
            }
            function lemiho_subscriber_session () {

                $status = session_status();

                if ( PHP_SESSION_DISABLED === $status ) {
                    // That's why you cannot rely on sessions!
                    return;
                }

                if ( PHP_SESSION_NONE === $status ) {
                    session_start();
                }
            }
            /**
             *@sent mail 
            */
            protected function lemiho_subscriber_sent_email($to,$title,$body_content){
                $content = $body_content . get_option('footer_email');
                $headers = array('Content-Type: text/html; charset=UTF-8');
    
                $sent = wp_mail( $to, $title, $content, $headers );
                return ($sent) ? true : false;
            }
            /**
             *@action delete report 
             */
            public function lemiho_subscriber_delete_report(){
                $database = new lemiho_subscriber_database;
                if(isset($_POST['lemiho_connect_system'])){
                    if(isset($_POST['data_id'])) :
                           if(is_numeric($_POST['data_id'])){
                               $delete = $database->lemiho_subscriber_database_delete_report(esc_html($_POST['data_id']));
                           }
                    endif;
                }
            }
            /**
             *@action lemiho pagination 
             */
            public function lemiho_subscriber_pagination_report(){
                $database = new lemiho_subscriber_database;
                $data_count = $database->lemiho_subscriber_data_count_report_result();
                $count = $data_count[0]->count;
                $__total_page = $count / 10;
                if($__total_page > 1 ) {
                    $_total_page = explode('.',$__total_page); 
                    $total_page = $_total_page[0];
                    $i = 0;
                    $number_text = 1;
                    while($i <= $total_page ) { 
                        $a = $i++; $show_text = $number_text++; 
                        $num = $a . '0';
                        if(isset($_GET['offset'])) {
                            $active = ($_GET['offset'] == $num) ? 'active' : ''; ?>
                            <a class="<?php echo $active; ?>" href="<?php echo home_url() . '/wp-admin/themes.php?page=lemiho-subsciber&tab=report&offset=' . $num; ?>"><?php echo $show_text; ?></a>
                        <?php } else {
                            if($a == 0 ) { ?>
                                <a class="active" href="<?php echo home_url() . '/wp-admin/themes.php?page=lemiho-subsciber&tab=report&offset=' . $num; ?>"><?php echo $show_text; ?></a>
                            <?php } else { ?>
                                <a class="<?php echo $active; ?>" href="<?php echo home_url() . '/wp-admin/themes.php?page=lemiho-subsciber&tab=report&offset=' . $num; ?>"><?php echo $show_text; ?></a>
                           <?php } 
                        } 
                    }
                }
            }
            /**
             *@action lemiho welcome email 
             */
            public function lemiho_subscriber_welcome_email($to){
                $subscriber = new lemiho_subscriber;
                $title = get_option('lemiho_subsciber_welcome_mail_title');
                $content = get_option('lemiho_subsciber_box_welcome_email');
                $subscriber->lemiho_subscriber_sent_email($to,$title,$content);
            }
            /**
             *@action member unsubscriber 
             */
            public function lemiho_subscriber_member_unsubscriber(){
                $subscriber = new lemiho_subscriber;
                $lemiho_subscriber_database = new lemiho_subscriber_database;
                if( isset($_GET['lemiho_subscriber']) && isset($_GET['lemiho_user_id']) && isset($_GET['lemiho_token'])) :
                        if(is_numeric($_GET['lemiho_user_id'])) : 
                              $check = $lemiho_subscriber_database->lemiho_subsciber_check_subscriber_by_id_time($_GET['lemiho_user_id'],$_GET['lemiho_token']);
                              if($check == true ) {
                                  $lemiho_subscriber_database->lemiho_subsciber_member_unsubscriber($_GET['lemiho_user_id']);
                              }
                        endif;    
                endif;    
            }
            /**
             *@hook  
             */
            public function lemiho_plugin_activation(){

            }
            public function lemiho_plugin_deactivation(){

            }
            /**
             *@action add keywords 
             */
            public function lemiho_subscriber_add_keywords(){
                    if(isset($_GET['lemiho_keyword_submit']) && isset($_GET['keyword'])) :
                        $database = new lemiho_subscriber_database;
                        $database->lemiho_subscriber_add_keyword($_GET);
                    endif;
            }
             public function lemiho_subscriber_update_keywords(){
                    if(isset($_GET['lemiho_keyword_submit_update']) && isset($_GET['keyword']) && isset($_GET['keyword_id'])) :
                        $database = new lemiho_subscriber_database;
                        $database->lemiho_subscriber_update_keyword($_GET);
                    endif;
            }
            public function lemiho_subscriber_delete_keyword(){
                    if(isset($_GET['lemiho_keyword_submit_delete']) && isset($_GET['keyword_id'])) :
                        $database = new lemiho_subscriber_database;
                        $database->lemiho_subscriber_delete_keyword($_GET);
                    endif;
            }
            /**
             *@export  
             */
            public function lemiho_subscriber_action_export(){
                if(isset($_GET['lemiho_subscriber_submit_export'])) {
                    $database = new lemiho_subscriber_database;
                    $data = $database->lemiho_subscriber_export();
                        //require '../PHPExcel/PHPExcel/IOFactory.php';
                        require_once(LEMIHO_SUBSCRIBER . 'PHPExcel/PHPExcel/IOFactory.php');
                        $fileType = 'Excel2007';
                        $fileName = md5(time()) . '.xlsx';
                        $objPHPExcel = PHPExcel_IOFactory::load(LEMIHO_SUBSCRIBER . "data.xlsx");
                        $i = 2;
                        $objPHPExcel->setActiveSheetIndex(0)
                            ->setCellValue('A1', "email")
                            ->setCellValue('B1', "data_key")
                            ->setCellValue('C1', "create");
                        foreach ($data as $value) {
                            $objPHPExcel->setActiveSheetIndex(0)
                                                        ->setCellValue("A$i", $value->email)
                                                        ->setCellValue("B$i", $value->data_key)
                                                        ->setCellValue("C$i", $value->create);
                            $i++;
                        }
                        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, $fileType);
                        $objWriter->save(LEMIHO_SUBSCRIBER . 'assets/export/' . $fileName);
                }
            }
            public function lemiho_subscriber_action_delete_file_excel(){
                if(isset($_POST['lemiho_excel_export']) && isset($_POST['file_name'])) :
                    unlink( LEMIHO_SUBSCRIBER . 'assets/export/' . $_POST['file_name']);
                endif;    
            }
    }
$lemiho = new lemiho_subscriber;     
add_action('admin_menu',array($lemiho,'lemiho_subscriber_manage_page'));
add_action('admin_init',array($lemiho,'lemiho_subscriber_section_field'));
add_action('template_redirect',array($lemiho,'lemiho_subscriber_session'));
add_action('wp_footer',array($lemiho,'lemiho_subscriber_member_unsubscriber'));    
endif;