<?php  
if(!class_exists('lemiho_subscriber_database')):
    class lemiho_subscriber_database {
          public function lemiho_subscriber_database_table_exists(){
                 global $wpdb;
                 $table_exists = $wpdb->get_var( "SHOW TABLES LIKE 'lemiho_subscriber'");
                 return (isset($table_exists)) ? true : false;
          }
          public function lemiho_subscriber_database_create_database(){
                 global $wpdb;
                 $create_table = $wpdb->get_var( "CREATE TABLE `lemiho_subscriber` (
                                                `id` int(11) AUTO_INCREMENT PRIMARY KEY,
                                                `email` varchar(150) COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `status` enum('on','off') COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `keywords` varchar(150) COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `data_key` varchar(150) COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                `update` datetime NOT NULL
                                                )");
                return ($create_table) ? true : false;                                
          }
          public function lemiho_subsciber_get_subscriber(){
                global $wpdb;
                $groupID = esc_html(get_option('lemiho_subsciber_group_sent_email'));
                $sql = "SELECT * FROM lemiho_subscriber WHERE `status`='on' AND `keywords` IN ('{$groupID}','')";
                $data = $wpdb->get_results($sql);
                return $data;
          }
          public function lemiho_subsciber_member__subscriber($email,$group){
                global $wpdb;
                $select = "SELECT COUNT(*) as count FROM lemiho_subscriber WHERE email='{$email}'";
                $get = $wpdb->get_results($select);
                $register = $get[0];
                if($register->count == 0) {
                     $time =  date('Y-m-d H:i:s',time());
                     $data_key = md5($time);
                     $sql = "INSERT INTO lemiho_subscriber (`email`,`status`,`keywords`,`data_key`) VALUES ('{$email}','on','{$group}','{$data_key}')";
                     $insert = $wpdb->query($sql);
                     return ($insert) ? true : false;
                } else {
                    $update = $this->lemiho_subsciber_subscriber_again($email);
                    return ($update == true ) ? true : false;
                }
            }
            protected function lemiho_subsciber_subscriber_again($email){
                  global $wpdb;
                  $update = $wpdb->update('lemiho_subscriber',array('status' => 'on'),array('email' => $email));
                  return ($update) ? true : false;
            }
            public function lemiho_subsciber_member_unsubscriber($id){
                  global $wpdb;
                  $update = $wpdb->update('lemiho_subscriber',array('status' => 'off'),array('id' => $id));
                  return ($update) ? true : false;
            }
            public function lemiho_subsciber_check_subscriber_by_id_time($id,$token){
                  global $wpdb;
                  $sql = "SELECT COUNT(*) AS count FROM lemiho_subscriber WHERE `id`='{$id}' AND `data_key`='{$token}'";
                  $data = $wpdb->get_results($sql);
                  return ($data[0]->count >= 1 ) ? true : false;
            }
            public function lemiho_subsciber_member_update_time($email){
                  global $wpdb;
                  $time = date('Y-m-d H:i:s',time());
                  $sql = "UPDATE lemiho_subscriber SET `update`='{$time}' WHERE email='{$email}'";
                  $update = $wpdb->query($sql);
                  return ($update) ? true : false;
            }
            /**
             *@Report  
            */
            public function lemiho_subscriber_database_table_report_exists(){
                        global $wpdb;
                        $table_exists = $wpdb->get_var( "SHOW TABLES LIKE 'lemiho_subscriber_report'");
                        return (isset($table_exists)) ? true : false;
            }
            public function lemiho_subscriber_database_create_table_report(){
                  global $wpdb;
                  $create_table = $wpdb->get_var( "CREATE TABLE `lemiho_subscriber_report` (
                                                `id` int(11) AUTO_INCREMENT PRIMARY KEY,
                                                `subscriber` int(11) NOT NULL,
                                                `unsubscriber` int(11) NOT NULL,
                                                `create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                `update` datetime NOT NULL
                                                )");
                  return ($create_table) ? true : false;                                
            }
            public function lemiho_subscriber_database_create_report($subscriber,$unsubscriber){
                  global $wpdb;
                  $sql = "INSERT INTO lemiho_subscriber_report (subscriber,unsubscriber) VALUES ('{$subscriber}','{$unsubscriber}')";
                  $create = $wpdb->query($sql);
                  return ($create) ? true : false;
            }
            public function lemiho_subscriber_database_delete_report($id){
                  global $wpdb;
                  $sql = "DELETE FROM lemiho_subscriber_report WHERE id='{$id}'";
                  $create = $wpdb->query($sql);
                  return ($create) ? true : false;
            }
            public function lemiho_subscriber_database_result($offset){
                  global $wpdb;
                  $sql = "SELECT * FROM lemiho_subscriber_report ORDER BY id DESC LIMIT 10 OFFSET {$offset}";
                  $result = $wpdb->get_results($sql);
                  return $result;
            }
            public function lemiho_subscriber_data_count_report_result(){
                  global $wpdb;
                  $sql = "SELECT COUNT(*) AS count FROM lemiho_subscriber_report";
                  $result = $wpdb->get_results($sql);
                  return $result;
            }
            /**
             *@Dashboard
             *@Subscriber on 
             */
            public function lemiho_subscriber_database_get_all_subscriber(){
                  global $wpdb;
                  $sql = "SELECT COUNT(*) as count FROM lemiho_subscriber WHERE `status`='on'";
                  $data = $wpdb->get_results($sql);
                  return $data[0]->count;
            }
            /**
             *@Dashboard
             *@Subscriber off 
             */
            public function lemiho_subscriber_database_get_all_Unsubscriber(){
                  global $wpdb;
                  $sql = "SELECT COUNT(*) as count FROM lemiho_subscriber WHERE `status`='off'";
                  $data = $wpdb->get_results($sql);
                  return $data[0]->count;
            }
            /**
             *@Keywords table  
             */
            public function lemiho_subscriber_database_table_keywords_exists(){
                 global $wpdb;
                 $table_exists = $wpdb->get_var( "SHOW TABLES LIKE 'lemiho_subscriber_keywords'");
                 return (isset($table_exists)) ? true : false;
            }
            public function lemiho_subscriber_create_table_keywords(){
                 global $wpdb;
                 $create_table = $wpdb->get_var( "CREATE TABLE `lemiho_subscriber_keywords` (
                                                `id` int(11) AUTO_INCREMENT PRIMARY KEY,
                                                `keywords` varchar(150) COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `data_key` varchar(150) COLLATE utf8mb4_unicode_ci NOT NULL,
                                                `create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                                                `update` datetime NOT NULL
                                                )");
                return ($create_table) ? true : false;                                
            }
            public function lemiho_subscriber_add_keyword($data){
                  global $wpdb;
                  $data_key = md5(date('Y-m-d',time()));
                  $sql = "INSERT INTO lemiho_subscriber_keywords (`keywords`,`data_key`) VALUES ('{$data['keyword']}','{$data_key}')";
                  $insert = $wpdb->get_var($sql);
                  return ($insert) ? true : false;
            }
             public function lemiho_subscriber_update_keyword($data){
                  global $wpdb;
                  $update = $wpdb->update('lemiho_subscriber_keywords',array('keywords' => $_GET['keyword']),array('id' => $_GET['keyword_id']));
                  return ($update) ? true : false;
            }
             public function lemiho_subscriber_delete_keyword($data){
                  global $wpdb;
                  $sql = "DELETE FROM lemiho_subscriber_keywords WHERE id='{$data['keyword_id']}'";
                  $delete = $wpdb->query($sql);
                  return ($delete) ? true : false;
            }
            public function lemiho_subscriber_keyword_result(){
                  global $wpdb;
                  $sql = "SELECT * FROM lemiho_subscriber_keywords LIMIT 100";
                  $data = $wpdb->get_results($sql);
                  return $data;
            }
            /**
             *@export data 
             */
            public function lemiho_subscriber_export(){
                  global $wpdb;
                  $sql = "SELECT * FROM lemiho_subscriber";
                  $data = $wpdb->get_results($sql);
                  return $data;
            }
      }    
endif; 
    /**
     *@action create table author
     */
    $database = new lemiho_subscriber_database;
    $check_subscriber = $database->lemiho_subscriber_database_table_exists();
    if($check_subscriber == false ) {
        $database->lemiho_subscriber_database_create_database();
    }
    /**
     *@action create table report 
     */
    $check_report = $database->lemiho_subscriber_database_table_report_exists();
    if($check_report == false ) {
        $database->lemiho_subscriber_database_create_table_report();
    }
    /**
     *@action create table keywords
     */
    $check_keywords = $database->lemiho_subscriber_database_table_keywords_exists();
    if($check_keywords == false ) {
        $database->lemiho_subscriber_create_table_keywords();
    }
?>    